--- old/usr/src/common/crypto/modes/modes.h	Thu Apr 30 20:52:31 2015
+++ new/usr/src/common/crypto/modes/modes.h	Thu Apr 30 20:52:31 2015
@@ -22,6 +22,9 @@
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2015 by Saso Kiselkov. All rights reserved.
+ */
 
 #ifndef	_COMMON_CRYPTO_MODES_H
 #define	_COMMON_CRYPTO_MODES_H
@@ -187,34 +190,44 @@
  *			Length of processed plaintext (encrypt) or
  *			length of processed ciphertext (decrypt).
  *
- * gcm_pt_buf:		Stores the decrypted plaintext returned by
- *			decrypt_final when the computed authentication
- *			tag matches the	user supplied tag.
- *
- * gcm_pt_buf_len:	Length of the plaintext buffer.
- *
  * gcm_H:		Subkey.
  *
+ * gcm_H_table:		Pipelined Karatsuba multipliers.
+ *
  * gcm_J0:		Pre-counter block generated from the IV.
  *
+ * gcm_tmp:		Temp storage for ciphertext when padding is needed.
+ *
  * gcm_len_a_len_c:	64-bit representations of the bit lengths of
  *			AAD and ciphertext.
  *
  * gcm_kmflag:		Current value of kmflag. Used only for allocating
  *			the plaintext buffer during decryption.
+ *
+ * gcm_last_input:	Buffer of (up to) two last blocks. This is used when
+ *			input is not block-aligned and to temporarily hold
+ *			the end of the ciphertext stream during decryption,
+ *			since that could potentially be the GHASH auth tag
+ *			which we must check in the final() call instead of
+ *			decrypting it.
+ *
+ * gcm_last_input_fill:	Number of bytes actually stored in gcm_last_input.
  */
 typedef struct gcm_ctx {
 	struct common_ctx gcm_common;
 	size_t gcm_tag_len;
 	size_t gcm_processed_data_len;
-	size_t gcm_pt_buf_len;
-	uint32_t gcm_tmp[4];
 	uint64_t gcm_ghash[2];
 	uint64_t gcm_H[2];
+#ifdef	__amd64
+	uint8_t gcm_H_table[256];
+#endif
 	uint64_t gcm_J0[2];
+	uint64_t gcm_tmp[2];
 	uint64_t gcm_len_a_len_c[2];
-	uint8_t *gcm_pt_buf;
 	int gcm_kmflag;
+	uint8_t gcm_last_input[32];
+	size_t gcm_last_input_fill;
 } gcm_ctx_t;
 
 #define	gcm_keysched		gcm_common.cc_keysched
@@ -283,99 +296,109 @@
 #define	dc_lastp		dcu.dcu_ecb.ecb_common.cc_lastp
 
 extern int ecb_cipher_contiguous_blocks(ecb_ctx_t *, char *, size_t,
-    crypto_data_t *, size_t, int (*cipher)(const void *, const uint8_t *,
-    uint8_t *));
+    crypto_data_t *, size_t,
+    int (*cipher)(const void *, const uint8_t *, uint8_t *),
+    int (*cipher_ecb)(const void *, const uint8_t *, uint8_t *, uint64_t));
 
 extern int cbc_encrypt_contiguous_blocks(cbc_ctx_t *, char *, size_t,
     crypto_data_t *, size_t,
     int (*encrypt)(const void *, const uint8_t *, uint8_t *),
-    void (*copy_block)(uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *));
+    void (*copy_block)(const uint8_t *, uint8_t *),
+    void (*xor_block)(const uint8_t *, uint8_t *),
+    int (*encrypt_cbc)(const void *, const uint8_t *, uint8_t *,
+    const uint8_t *, uint64_t));
 
 extern int cbc_decrypt_contiguous_blocks(cbc_ctx_t *, char *, size_t,
     crypto_data_t *, size_t,
     int (*decrypt)(const void *, const uint8_t *, uint8_t *),
-    void (*copy_block)(uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *));
+    void (*copy_block)(const uint8_t *, uint8_t *),
+    void (*xor_block)(const uint8_t *, uint8_t *),
+    int (*decrypt_ecb)(const void *, const uint8_t *, uint8_t *, uint64_t),
+    void (*xor_block_range)(const uint8_t *, uint8_t *, uint64_t));
 
 extern int ctr_mode_contiguous_blocks(ctr_ctx_t *, char *, size_t,
     crypto_data_t *, size_t,
     int (*cipher)(const void *, const uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *));
+    void (*xor_block)(const uint8_t *, uint8_t *),
+    int (*cipher_ctr)(const void *, const uint8_t *, uint8_t *, uint64_t,
+    uint64_t *));
 
 extern int ccm_mode_encrypt_contiguous_blocks(ccm_ctx_t *, char *, size_t,
     crypto_data_t *, size_t,
     int (*encrypt_block)(const void *, const uint8_t *, uint8_t *),
-    void (*copy_block)(uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *));
+    void (*copy_block)(const uint8_t *, uint8_t *),
+    void (*xor_block)(const uint8_t *, uint8_t *));
 
 extern int ccm_mode_decrypt_contiguous_blocks(ccm_ctx_t *, char *, size_t,
     crypto_data_t *, size_t,
     int (*encrypt_block)(const void *, const uint8_t *, uint8_t *),
-    void (*copy_block)(uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *));
+    void (*copy_block)(const uint8_t *, uint8_t *),
+    void (*xor_block)(const uint8_t *, uint8_t *));
 
 extern int gcm_mode_encrypt_contiguous_blocks(gcm_ctx_t *, char *, size_t,
     crypto_data_t *, size_t,
     int (*encrypt_block)(const void *, const uint8_t *, uint8_t *),
-    void (*copy_block)(uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *));
+    void (*copy_block)(const uint8_t *, uint8_t *),
+    void (*xor_block)(const uint8_t *, uint8_t *),
+    int (*cipher_ctr)(const void *, const uint8_t *, uint8_t *, uint64_t,
+    uint64_t *));
 
 extern int gcm_mode_decrypt_contiguous_blocks(gcm_ctx_t *, char *, size_t,
     crypto_data_t *, size_t,
     int (*encrypt_block)(const void *, const uint8_t *, uint8_t *),
-    void (*copy_block)(uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *));
+    void (*copy_block)(const uint8_t *, uint8_t *),
+    void (*xor_block)(const uint8_t *, uint8_t *),
+    int (*cipher_ctr)(const void *, const uint8_t *, uint8_t *, uint64_t,
+    uint64_t *));
 
 int ccm_encrypt_final(ccm_ctx_t *, crypto_data_t *, size_t,
     int (*encrypt_block)(const void *, const uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *));
+    void (*xor_block)(const uint8_t *, uint8_t *));
 
 int gcm_encrypt_final(gcm_ctx_t *, crypto_data_t *, size_t,
     int (*encrypt_block)(const void *, const uint8_t *, uint8_t *),
-    void (*copy_block)(uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *));
+    void (*copy_block)(const uint8_t *, uint8_t *),
+    void (*xor_block)(const uint8_t *, uint8_t *));
 
 extern int ccm_decrypt_final(ccm_ctx_t *, crypto_data_t *, size_t,
     int (*encrypt_block)(const void *, const uint8_t *, uint8_t *),
-    void (*copy_block)(uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *));
+    void (*copy_block)(const uint8_t *, uint8_t *),
+    void (*xor_block)(const uint8_t *, uint8_t *));
 
 extern int gcm_decrypt_final(gcm_ctx_t *, crypto_data_t *, size_t,
     int (*encrypt_block)(const void *, const uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *));
+    void (*copy_block)(const uint8_t *, uint8_t *),
+    void (*xor_block)(const uint8_t *, uint8_t *),
+    int (*cipher_ctr)(const void *, const uint8_t *, uint8_t *, uint64_t,
+    uint64_t *));
 
 extern int ctr_mode_final(ctr_ctx_t *, crypto_data_t *,
     int (*encrypt_block)(const void *, const uint8_t *, uint8_t *));
 
 extern int cbc_init_ctx(cbc_ctx_t *, char *, size_t, size_t,
-    void (*copy_block)(uint8_t *, uint64_t *));
+    void (*copy_block)(const uint8_t *, uint64_t *));
 
 extern int ctr_init_ctx(ctr_ctx_t *, ulong_t, uint8_t *,
-    void (*copy_block)(uint8_t *, uint8_t *));
+    void (*copy_block)(const uint8_t *, uint8_t *));
 
 extern int ccm_init_ctx(ccm_ctx_t *, char *, int, boolean_t, size_t,
     int (*encrypt_block)(const void *, const uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *));
+    void (*xor_block)(const uint8_t *, uint8_t *));
 
 extern int gcm_init_ctx(gcm_ctx_t *, char *, size_t,
     int (*encrypt_block)(const void *, const uint8_t *, uint8_t *),
-    void (*copy_block)(uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *));
+    void (*copy_block)(const uint8_t *, uint8_t *),
+    void (*xor_block)(const uint8_t *, uint8_t *));
 
 extern int gmac_init_ctx(gcm_ctx_t *, char *, size_t,
     int (*encrypt_block)(const void *, const uint8_t *, uint8_t *),
-    void (*copy_block)(uint8_t *, uint8_t *),
-    void (*xor_block)(uint8_t *, uint8_t *));
+    void (*copy_block)(const uint8_t *, uint8_t *),
+    void (*xor_block)(const uint8_t *, uint8_t *));
 
 extern void calculate_ccm_mac(ccm_ctx_t *, uint8_t *,
     int (*encrypt_block)(const void *, const uint8_t *, uint8_t *));
 
-extern void gcm_mul(uint64_t *, uint64_t *, uint64_t *);
-
 extern void crypto_init_ptrs(crypto_data_t *, void **, offset_t *);
-extern void crypto_get_ptrs(crypto_data_t *, void **, offset_t *,
-    uint8_t **, size_t *, uint8_t **, size_t);
 
 extern void *ecb_alloc_ctx(int);
 extern void *cbc_alloc_ctx(int);
@@ -386,6 +409,115 @@
 extern void crypto_free_mode_ctx(void *);
 extern void gcm_set_kmflag(gcm_ctx_t *, int);
 
+#ifdef	INLINE_CRYPTO_GET_PTRS
+/*
+ * Get pointers for where in the output to copy a block of encrypted or
+ * decrypted data.  The iov_or_mp argument stores a pointer to the current
+ * iovec or mp, and offset stores an offset into the current iovec or mp.
+ */
+static inline void
+crypto_get_ptrs(crypto_data_t *out, void **iov_or_mp, offset_t *current_offset,
+    uint8_t **out_data_1, size_t *out_data_1_len, uint8_t **out_data_2,
+    size_t amt)
+{
+	offset_t offset;
+
+	switch (out->cd_format) {
+	case CRYPTO_DATA_RAW: {
+		iovec_t *iov;
+
+		offset = *current_offset;
+		iov = &out->cd_raw;
+		if ((offset + amt) <= iov->iov_len) {
+			/* one block fits */
+			*out_data_1 = (uint8_t *)iov->iov_base + offset;
+			*out_data_1_len = amt;
+			*out_data_2 = NULL;
+			*current_offset = offset + amt;
+		}
+		break;
+	}
+
+	case CRYPTO_DATA_UIO: {
+		uio_t *uio = out->cd_uio;
+		iovec_t *iov;
+		offset_t offset;
+		uintptr_t vec_idx;
+		uint8_t *p;
+
+		offset = *current_offset;
+		vec_idx = (uintptr_t)(*iov_or_mp);
+		iov = &uio->uio_iov[vec_idx];
+		p = (uint8_t *)iov->iov_base + offset;
+		*out_data_1 = p;
+
+		if (offset + amt <= iov->iov_len) {
+			/* can fit one block into this iov */
+			*out_data_1_len = amt;
+			*out_data_2 = NULL;
+			*current_offset = offset + amt;
+		} else {
+			/* one block spans two iovecs */
+			*out_data_1_len = iov->iov_len - offset;
+			if (vec_idx == uio->uio_iovcnt)
+				return;
+			vec_idx++;
+			iov = &uio->uio_iov[vec_idx];
+			*out_data_2 = (uint8_t *)iov->iov_base;
+			*current_offset = amt - *out_data_1_len;
+		}
+		*iov_or_mp = (void *)vec_idx;
+		break;
+	}
+
+	case CRYPTO_DATA_MBLK: {
+		mblk_t *mp;
+		uint8_t *p;
+
+		offset = *current_offset;
+		mp = (mblk_t *)*iov_or_mp;
+		p = mp->b_rptr + offset;
+		*out_data_1 = p;
+		if ((p + amt) <= mp->b_wptr) {
+			/* can fit one block into this mblk */
+			*out_data_1_len = amt;
+			*out_data_2 = NULL;
+			*current_offset = offset + amt;
+		} else {
+			/* one block spans two mblks */
+			*out_data_1_len = _PTRDIFF(mp->b_wptr, p);
+			if ((mp = mp->b_cont) == NULL)
+				return;
+			*out_data_2 = mp->b_rptr;
+			*current_offset = (amt - *out_data_1_len);
+		}
+		*iov_or_mp = mp;
+		break;
+	}
+	} /* end switch */
+}
+#endif	/* INLINE_CRYPTO_GET_PTRS */
+
+/*
+ * Checks whether a crypto_data_t object is composed of a single contiguous
+ * buffer. This is used in all fastpath detection code to avoid the
+ * possibility of having to do partial block splicing.
+ */
+#define	CRYPTO_DATA_IS_SINGLE_BLOCK(cd) \
+	(cd != NULL && (cd->cd_format == CRYPTO_DATA_RAW || \
+	(cd->cd_format == CRYPTO_DATA_UIO && cd->cd_uio->uio_iovcnt == 1) || \
+	(cd->cd_format == CRYPTO_DATA_MBLK && cd->cd_mp->b_next == NULL)))
+
+/*
+ * Returns the first contiguous data buffer in a crypto_data_t object.
+ */
+#define	CRYPTO_DATA_FIRST_BLOCK(cd) \
+	(cd->cd_format == CRYPTO_DATA_RAW ? \
+	(void *)(cd->cd_raw.iov_base + cd->cd_offset) : \
+	(cd->cd_format == CRYPTO_DATA_UIO ? \
+	(void *)(cd->cd_uio->uio_iov[0].iov_base + cd->cd_offset) : \
+	(void *)(cd->cd_mp->b_rptr + cd->cd_offset)))
+
 #ifdef	__cplusplus
 }
 #endif
--- old/usr/src/lib/pkcs11/libsoftcrypto/amd64/Makefile	Thu Apr 30 20:52:31 2015
+++ new/usr/src/lib/pkcs11/libsoftcrypto/amd64/Makefile	Thu Apr 30 20:52:31 2015
@@ -21,6 +21,7 @@
 
 #
 # Copyright (c) 2008, 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2015 by Saso Kiselkov. All rights reserved.
 #
 
 LIBRARY =	libsoftcrypto.a
@@ -38,6 +39,7 @@
 CERRWARN +=	-_gcc=-Wno-type-limits
 CERRWARN +=	-_gcc=-Wno-parentheses
 CERRWARN +=	-_gcc=-Wno-uninitialized
+C99MODE =	$(C99_ENABLE)
 
 AES_PSM_SRC =	$(AES_DIR)/$(MACH64)/aes_amd64.s \
 		$(AES_DIR)/$(MACH64)/aes_intel.s \
--- old/usr/src/lib/pkcs11/libsoftcrypto/i386/Makefile	Thu Apr 30 20:52:31 2015
+++ new/usr/src/lib/pkcs11/libsoftcrypto/i386/Makefile	Thu Apr 30 20:52:31 2015
@@ -21,6 +21,7 @@
 
 #
 # Copyright (c) 2008, 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2015 by Saso Kiselkov. All rights reserved.
 #
 
 LIBRARY =	libsoftcrypto.a
@@ -33,6 +34,7 @@
 CERRWARN +=	-_gcc=-Wno-type-limits
 CERRWARN +=	-_gcc=-Wno-parentheses
 CERRWARN +=	-_gcc=-Wno-uninitialized
+C99MODE =	$(C99_ENABLE)
 
 # Sources need to be redefined after Makefile.lib inclusion.
 SRCS =		$(AES_SRC) $(ARCFOUR_SRC) $(BIGNUM_SRC) $(BLOWFISH_SRC) \
--- old/usr/src/uts/common/crypto/core/kcf_prov_lib.c	Thu Apr 30 20:52:32 2015
+++ new/usr/src/uts/common/crypto/core/kcf_prov_lib.c	Thu Apr 30 20:52:32 2015
@@ -22,6 +22,9 @@
  * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2015 by Saso Kiselkov. All rights reserved.
+ */
 
 #include <sys/strsun.h>
 #include <sys/systm.h>
@@ -396,7 +399,7 @@
 int
 crypto_update_iov(void *ctx, crypto_data_t *input, crypto_data_t *output,
     int (*cipher)(void *, caddr_t, size_t, crypto_data_t *),
-    void (*copy_block)(uint8_t *, uint64_t *))
+    void (*copy_block)(const uint8_t *, uint64_t *))
 {
 	common_ctx_t *common_ctx = ctx;
 	int rv;
@@ -418,7 +421,7 @@
 int
 crypto_update_uio(void *ctx, crypto_data_t *input, crypto_data_t *output,
     int (*cipher)(void *, caddr_t, size_t, crypto_data_t *),
-    void (*copy_block)(uint8_t *, uint64_t *))
+    void (*copy_block)(const uint8_t *, uint64_t *))
 {
 	common_ctx_t *common_ctx = ctx;
 	uio_t *uiop = input->cd_uio;
@@ -483,7 +486,7 @@
 int
 crypto_update_mp(void *ctx, crypto_data_t *input, crypto_data_t *output,
     int (*cipher)(void *, caddr_t, size_t, crypto_data_t *),
-    void (*copy_block)(uint8_t *, uint64_t *))
+    void (*copy_block)(const uint8_t *, uint64_t *))
 {
 	common_ctx_t *common_ctx = ctx;
 	off_t offset = input->cd_offset;
--- old/usr/src/uts/common/crypto/io/aes.c	Thu Apr 30 20:52:32 2015
+++ new/usr/src/uts/common/crypto/io/aes.c	Thu Apr 30 20:52:32 2015
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 2003, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2015 by Saso Kiselkov. All rights reserved.
  */
 
 /*
@@ -386,7 +387,7 @@
 }
 
 static void
-aes_copy_block64(uint8_t *in, uint64_t *out)
+aes_copy_block64(const uint8_t *in, uint64_t *out)
 {
 	if (IS_P2ALIGNED(in, sizeof (uint64_t))) {
 		/* LINTED: pointer alignment */
@@ -396,7 +397,7 @@
 	} else {
 		uint8_t *iv8 = (uint8_t *)&out[0];
 
-		AES_COPY_BLOCK(in, iv8);
+		AES_COPY_BLOCK_UNALIGNED(in, iv8);
 	}
 }
 
@@ -475,7 +476,7 @@
 		ciphertext->cd_offset = ciphertext->cd_length;
 		ciphertext->cd_length = saved_length - ciphertext->cd_length;
 		ret = ccm_encrypt_final((ccm_ctx_t *)aes_ctx, ciphertext,
-		    AES_BLOCK_LEN, aes_encrypt_block, aes_xor_block);
+		    AES_BLOCK_LEN, aes_encrypt_block, AES_XOR_BLOCK);
 		if (ret != CRYPTO_SUCCESS) {
 			return (ret);
 		}
@@ -496,8 +497,8 @@
 		ciphertext->cd_offset = ciphertext->cd_length;
 		ciphertext->cd_length = saved_length - ciphertext->cd_length;
 		ret = gcm_encrypt_final((gcm_ctx_t *)aes_ctx, ciphertext,
-		    AES_BLOCK_LEN, aes_encrypt_block, aes_copy_block,
-		    aes_xor_block);
+		    AES_BLOCK_LEN, aes_encrypt_block, AES_COPY_BLOCK,
+		    AES_XOR_BLOCK);
 		if (ret != CRYPTO_SUCCESS) {
 			return (ret);
 		}
@@ -590,8 +591,8 @@
 		plaintext->cd_length = saved_length - plaintext->cd_length;
 
 		ret = ccm_decrypt_final((ccm_ctx_t *)aes_ctx, plaintext,
-		    AES_BLOCK_LEN, aes_encrypt_block, aes_copy_block,
-		    aes_xor_block);
+		    AES_BLOCK_LEN, aes_encrypt_block, AES_COPY_BLOCK,
+		    AES_XOR_BLOCK);
 		if (ret == CRYPTO_SUCCESS) {
 			if (plaintext != ciphertext) {
 				plaintext->cd_length =
@@ -608,7 +609,8 @@
 		plaintext->cd_length = saved_length - plaintext->cd_length;
 
 		ret = gcm_decrypt_final((gcm_ctx_t *)aes_ctx, plaintext,
-		    AES_BLOCK_LEN, aes_encrypt_block, aes_xor_block);
+		    AES_BLOCK_LEN, aes_encrypt_block, AES_XOR_BLOCK,
+		    AES_COPY_BLOCK, aes_ctr_mode);
 		if (ret == CRYPTO_SUCCESS) {
 			if (plaintext != ciphertext) {
 				plaintext->cd_length =
@@ -722,13 +724,15 @@
 
 	/*
 	 * Compute number of bytes that will hold the plaintext.
-	 * This is not necessary for CCM, GCM, and GMAC since these
+	 * This is not necessary for CCM and GMAC since these
 	 * mechanisms never return plaintext for update operations.
 	 */
-	if ((aes_ctx->ac_flags & (CCM_MODE|GCM_MODE|GMAC_MODE)) == 0) {
+	if ((aes_ctx->ac_flags & (CCM_MODE|GMAC_MODE)) == 0) {
 		out_len = aes_ctx->ac_remainder_len;
 		out_len += ciphertext->cd_length;
 		out_len &= ~(AES_BLOCK_LEN - 1);
+		if (aes_ctx->ac_flags & GCM_MODE)
+			out_len -= ((gcm_ctx_t *)aes_ctx)->gcm_tag_len;
 
 		/* return length needed to store the output */
 		if (plaintext->cd_length < out_len) {
@@ -818,7 +822,7 @@
 		}
 	} else if (aes_ctx->ac_flags & CCM_MODE) {
 		ret = ccm_encrypt_final((ccm_ctx_t *)aes_ctx, data,
-		    AES_BLOCK_LEN, aes_encrypt_block, aes_xor_block);
+		    AES_BLOCK_LEN, aes_encrypt_block, AES_XOR_BLOCK);
 		if (ret != CRYPTO_SUCCESS) {
 			return (ret);
 		}
@@ -826,8 +830,8 @@
 		size_t saved_offset = data->cd_offset;
 
 		ret = gcm_encrypt_final((gcm_ctx_t *)aes_ctx, data,
-		    AES_BLOCK_LEN, aes_encrypt_block, aes_copy_block,
-		    aes_xor_block);
+		    AES_BLOCK_LEN, aes_encrypt_block, AES_COPY_BLOCK,
+		    AES_XOR_BLOCK);
 		if (ret != CRYPTO_SUCCESS) {
 			return (ret);
 		}
@@ -903,8 +907,8 @@
 		saved_offset = data->cd_offset;
 		saved_length = data->cd_length;
 		ret = ccm_decrypt_final((ccm_ctx_t *)aes_ctx, data,
-		    AES_BLOCK_LEN, aes_encrypt_block, aes_copy_block,
-		    aes_xor_block);
+		    AES_BLOCK_LEN, aes_encrypt_block, AES_COPY_BLOCK,
+		    AES_XOR_BLOCK);
 		if (ret == CRYPTO_SUCCESS) {
 			data->cd_length = data->cd_offset - saved_offset;
 		} else {
@@ -917,21 +921,21 @@
 		}
 	} else if (aes_ctx->ac_flags & (GCM_MODE|GMAC_MODE)) {
 		/*
-		 * This is where all the plaintext is returned, make sure
-		 * the plaintext buffer is big enough
+		 * Check to make sure there is enough space for remaining
+		 * plaintext.
 		 */
 		gcm_ctx_t *ctx = (gcm_ctx_t *)aes_ctx;
-		size_t pt_len = ctx->gcm_processed_data_len - ctx->gcm_tag_len;
+		size_t pt_len = ctx->gcm_last_input_fill - ctx->gcm_tag_len;
 
 		if (data->cd_length < pt_len) {
 			data->cd_length = pt_len;
 			return (CRYPTO_BUFFER_TOO_SMALL);
 		}
-
 		saved_offset = data->cd_offset;
 		saved_length = data->cd_length;
 		ret = gcm_decrypt_final((gcm_ctx_t *)aes_ctx, data,
-		    AES_BLOCK_LEN, aes_encrypt_block, aes_xor_block);
+		    AES_BLOCK_LEN, aes_encrypt_block, AES_COPY_BLOCK,
+		    AES_XOR_BLOCK, aes_ctr_mode);
 		if (ret == CRYPTO_SUCCESS) {
 			data->cd_length = data->cd_offset - saved_offset;
 		} else {
@@ -944,7 +948,6 @@
 		}
 	}
 
-
 	if ((aes_ctx->ac_flags & (CTR_MODE|CCM_MODE|GCM_MODE|GMAC_MODE)) == 0) {
 		data->cd_length = 0;
 	}
@@ -1043,7 +1046,7 @@
 		if (mechanism->cm_type == AES_CCM_MECH_INFO_TYPE) {
 			ret = ccm_encrypt_final((ccm_ctx_t *)&aes_ctx,
 			    ciphertext, AES_BLOCK_LEN, aes_encrypt_block,
-			    aes_xor_block);
+			    AES_XOR_BLOCK);
 			if (ret != CRYPTO_SUCCESS)
 				goto out;
 			ASSERT(aes_ctx.ac_remainder_len == 0);
@@ -1051,7 +1054,7 @@
 		    mechanism->cm_type == AES_GMAC_MECH_INFO_TYPE) {
 			ret = gcm_encrypt_final((gcm_ctx_t *)&aes_ctx,
 			    ciphertext, AES_BLOCK_LEN, aes_encrypt_block,
-			    aes_copy_block, aes_xor_block);
+			    AES_COPY_BLOCK, AES_XOR_BLOCK);
 			if (ret != CRYPTO_SUCCESS)
 				goto out;
 			ASSERT(aes_ctx.ac_remainder_len == 0);
@@ -1182,7 +1185,7 @@
 			    == aes_ctx.ac_mac_len);
 			ret = ccm_decrypt_final((ccm_ctx_t *)&aes_ctx,
 			    plaintext, AES_BLOCK_LEN, aes_encrypt_block,
-			    aes_copy_block, aes_xor_block);
+			    AES_COPY_BLOCK, AES_XOR_BLOCK);
 			ASSERT(aes_ctx.ac_remainder_len == 0);
 			if ((ret == CRYPTO_SUCCESS) &&
 			    (ciphertext != plaintext)) {
@@ -1195,7 +1198,7 @@
 		    mechanism->cm_type == AES_GMAC_MECH_INFO_TYPE) {
 			ret = gcm_decrypt_final((gcm_ctx_t *)&aes_ctx,
 			    plaintext, AES_BLOCK_LEN, aes_encrypt_block,
-			    aes_xor_block);
+			    AES_COPY_BLOCK, AES_XOR_BLOCK, aes_ctr_mode);
 			ASSERT(aes_ctx.ac_remainder_len == 0);
 			if ((ret == CRYPTO_SUCCESS) &&
 			    (ciphertext != plaintext)) {
@@ -1237,11 +1240,6 @@
 		if (aes_ctx.ac_pt_buf != NULL) {
 			kmem_free(aes_ctx.ac_pt_buf, aes_ctx.ac_data_len);
 		}
-	} else if (aes_ctx.ac_flags & (GCM_MODE|GMAC_MODE)) {
-		if (((gcm_ctx_t *)&aes_ctx)->gcm_pt_buf != NULL) {
-			kmem_free(((gcm_ctx_t *)&aes_ctx)->gcm_pt_buf,
-			    ((gcm_ctx_t *)&aes_ctx)->gcm_pt_buf_len);
-		}
 	}
 
 	return (ret);
@@ -1352,7 +1350,7 @@
 		}
 		pp = (CK_AES_CTR_PARAMS *)(void *)mechanism->cm_param;
 		rv = ctr_init_ctx((ctr_ctx_t *)aes_ctx, pp->ulCounterBits,
-		    pp->cb, aes_copy_block);
+		    pp->cb, AES_COPY_BLOCK);
 		break;
 	}
 	case AES_CCM_MECH_INFO_TYPE:
@@ -1362,7 +1360,7 @@
 		}
 		rv = ccm_init_ctx((ccm_ctx_t *)aes_ctx, mechanism->cm_param,
 		    kmflag, is_encrypt_init, AES_BLOCK_LEN, aes_encrypt_block,
-		    aes_xor_block);
+		    AES_XOR_BLOCK);
 		break;
 	case AES_GCM_MECH_INFO_TYPE:
 		if (mechanism->cm_param == NULL ||
@@ -1370,8 +1368,8 @@
 			return (CRYPTO_MECHANISM_PARAM_INVALID);
 		}
 		rv = gcm_init_ctx((gcm_ctx_t *)aes_ctx, mechanism->cm_param,
-		    AES_BLOCK_LEN, aes_encrypt_block, aes_copy_block,
-		    aes_xor_block);
+		    AES_BLOCK_LEN, aes_encrypt_block, AES_COPY_BLOCK,
+		    AES_XOR_BLOCK);
 		break;
 	case AES_GMAC_MECH_INFO_TYPE:
 		if (mechanism->cm_param == NULL ||
@@ -1379,8 +1377,8 @@
 			return (CRYPTO_MECHANISM_PARAM_INVALID);
 		}
 		rv = gmac_init_ctx((gcm_ctx_t *)aes_ctx, mechanism->cm_param,
-		    AES_BLOCK_LEN, aes_encrypt_block, aes_copy_block,
-		    aes_xor_block);
+		    AES_BLOCK_LEN, aes_encrypt_block, AES_COPY_BLOCK,
+		    AES_XOR_BLOCK);
 		break;
 	case AES_ECB_MECH_INFO_TYPE:
 		aes_ctx->ac_flags |= ECB_MODE;
--- old/usr/src/uts/common/crypto/io/blowfish.c	Thu Apr 30 20:52:32 2015
+++ new/usr/src/uts/common/crypto/io/blowfish.c	Thu Apr 30 20:52:32 2015
@@ -22,6 +22,9 @@
  * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2015 by Saso Kiselkov. All rights reserved.
+ */
 
 /*
  * Blowfish provider for the Kernel Cryptographic Framework (KCF)
@@ -319,7 +322,7 @@
 }
 
 static void
-blowfish_copy_block64(uint8_t *in, uint64_t *out)
+blowfish_copy_block64(const uint8_t *in, uint64_t *out)
 {
 	if (IS_P2ALIGNED(in, sizeof (uint64_t))) {
 		/* LINTED: pointer alignment */
--- old/usr/src/uts/common/des/des_crypt.c	Thu Apr 30 20:52:32 2015
+++ new/usr/src/uts/common/des/des_crypt.c	Thu Apr 30 20:52:32 2015
@@ -23,6 +23,9 @@
  * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2015 by Saso Kiselkov. All rights reserved.
+ */
 
 /*	Copyright (c) 1983, 1984, 1985, 1986, 1987, 1988, 1989 AT&T	*/
 /*	  All Rights Reserved  	*/
@@ -492,7 +495,7 @@
 }
 
 static void
-des_copy_block64(uint8_t *in, uint64_t *out)
+des_copy_block64(const uint8_t *in, uint64_t *out)
 {
 	if (IS_P2ALIGNED(in, sizeof (uint64_t))) {
 		/* LINTED: pointer alignment */
--- old/usr/src/uts/common/sys/crypto/impl.h	Thu Apr 30 20:52:32 2015
+++ new/usr/src/uts/common/sys/crypto/impl.h	Thu Apr 30 20:52:32 2015
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 2003, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2015 by Saso Kiselkov. All rights reserved.
  */
 
 #ifndef	_SYS_CRYPTO_IMPL_H
@@ -1356,13 +1357,13 @@
     void (*update)(), void (*final)(), uchar_t);
 extern int crypto_update_iov(void *, crypto_data_t *, crypto_data_t *,
     int (*cipher)(void *, caddr_t, size_t, crypto_data_t *),
-    void (*copy_block)(uint8_t *, uint64_t *));
+    void (*copy_block)(const uint8_t *, uint64_t *));
 extern int crypto_update_uio(void *, crypto_data_t *, crypto_data_t *,
     int (*cipher)(void *, caddr_t, size_t, crypto_data_t *),
-    void (*copy_block)(uint8_t *, uint64_t *));
+    void (*copy_block)(const uint8_t *, uint64_t *));
 extern int crypto_update_mp(void *, crypto_data_t *, crypto_data_t *,
     int (*cipher)(void *, caddr_t, size_t, crypto_data_t *),
-    void (*copy_block)(uint8_t *, uint64_t *));
+    void (*copy_block)(const uint8_t *, uint64_t *));
 extern int crypto_get_key_attr(crypto_key_t *, crypto_attr_type_t, uchar_t **,
     ssize_t *);
 
--- old/usr/src/uts/intel/kcf/Makefile	Thu Apr 30 20:52:32 2015
+++ new/usr/src/uts/intel/kcf/Makefile	Thu Apr 30 20:52:32 2015
@@ -21,6 +21,7 @@
 #
 # Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2015 by Saso Kiselkov. All rights reserved.
 #
 #	This makefile drives the production of the Kernel Cryptographic
 #	Framework core module.
@@ -40,7 +41,7 @@
 MODULE		= kcf
 LINTS		= $(KCF_OBJS:%.o=$(LINTS_DIR)/%.ln)
 KCF_OBJS_32	=
-KCF_OBJS_64	= gcm_intel.o
+KCF_OBJS_64	= gcm_intel.o gcm_intel_cryptogams.o
 KCF_OBJS	+= $(KCF_OBJS_$(CLASS))
 OBJECTS		= $(KCF_OBJS:%=$(OBJS_DIR)/%)
 ROOTMODULE	= $(ROOT_MISC_DIR)/$(MODULE)
